/*
Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Appello del 11/07/2007

Tempo a disposizione: 2h  30m

Scrivere un programma per la gestione dei DVD e dei relativi noleggi.
I DVD sono caratterizzati dalle seguenti informazioni: titolo, collocazione, genere del DVD.
I DVD sono inseriti in una tabella allocata dinamicamente avente 4 righe, una per ogni genere di DVD.
Per quanto riguarda i noleggi, essi sono caratterizzati dalle seguenti informazioni: codice cliente, titolo, giorno del prestito, genere del DVD.
Ogni nuovo noleggio viene inserito in un vettore di 4 liste, una per ogni genere di DVD.
Ogni lista  ordinata rispetto al codice del cliente.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento di un nuovo DVD;
2.Visualizzazione dei DVD relativi a un certo genere;
3.Inserimento ordinato di un noleggio nella lista relativa al suo genere;
4.Visualizzazione dei noleggi relativi a un certo genere;
5.Salvataggio su file del contenuto del contenuto della tabella.

Allavvio del programma i DVD precedentemente salvati su file devono essere letti e copiati nella tabella mediante una funzione di inizializzazione della tabella.

Liberare la memoria allocata dinamicamente.



*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
	char titolo[20];
	int collocazione;
	int genere;
		}dvd;

typedef struct{
	int cliente;
	char titolo[20];
	char giorno[11];
	int genere;
		}prestito;

struct atomo{
	prestito dato;
	struct atomo *next;
	};

void leggi(dvd *x);
void ins_tab(dvd *T[4],int *N, dvd d);
void vis_riga(dvd *R,int nr);

void ins_lista(struct atomo *tl[4]);
void vis_lista(struct atomo *tl);
void libera_lista(struct atomo **tl);
void menu();
void salva(dvd *T[4],int *N);
void inizializza(dvd *T[4],int *N);



main(){

	dvd *T[4],x;
	int N[4],scelta,i;
	struct atomo *L[4];

	for(i=0;i<5;i++)
		{
			T[i]=NULL;
			N[i]=0;
			L[i]=NULL;
		}

   	inizializza(T,N);
	do{
		menu();
		scanf("%d",&scelta);
		switch(scelta){

			case 1: leggi(&x);
					ins_tab(T,N,x);
					break;

			case 2: printf("Genere: ");
					scanf("%d",&i);
					vis_riga(T[i],N[i]);
					break;

			case 3: ins_lista(L);
					break;
			case 4: printf("Genere?\n");
					scanf("%d",&i);
					vis_lista(L[i]);
					break;
			case 5: salva(T,N);
					break;
			case 0: printf("Fine\n");
					break;
			default:printf("Tasto errato\n");}
			}while(scelta!=0);

			for(i=0;i<4;i++)
			 {	free(T[i]);
				libera_lista(&L[i]);
			}
}


void leggi(dvd *x)
{
	printf("Titolo:\n");
	scanf("%s",x->titolo);
	printf("Collocazione:\n");
	scanf("%d",&x->collocazione);
	printf("Genere:\n");
	scanf("%d",&x->genere);
	}


void ins_tab(dvd *T[5],int *N,dvd x)
{
	dvd *R;
   int g;

    g=x.genere;
    R=realloc(T[g],sizeof (dvd)*(N[g]+1));
	if(R==NULL)
		{
			printf("Memoria non allocata\n");
			return;
		}

	T[g]=R;
	T[g][N[g]]=x;
	N[g]++;
}

void vis_riga(dvd *R,int nr)
{
	int i;

	for(i=0;i<nr;i++)
		{
			printf("Titolo:%s\n",R[i].titolo);
			printf("Collocazione:%d\n",R[i].collocazione);
		}
	}


void ins_lista(struct atomo *tl[4])
{
	prestito x;
	int g;
	struct atomo *aux,*l1,*l2;

	aux=malloc(sizeof (struct atomo));
	if(aux==NULL)
		{
			printf("Memoria non allocata\n");
			return;
		}

	printf("Titolo:\n");
	scanf("%s",x.titolo);
	printf("Giorno:\n");
	scanf("%s",x.giorno);
	printf("Codice cliente: \n");
	scanf("%d",&x.cliente);
	printf("Genere:\n");
	scanf("%d",&x.genere);
	g=x.genere;

	aux->dato=x;


	if(tl[g]==NULL || aux->dato.cliente<tl[g]->dato.cliente)
		{
			aux->next=tl[g];
			tl[g]=aux;
			return;
		}
	l2=tl[g];
	l1=l2->next;
	while(l1!=NULL)
		if(aux->dato.cliente<l1->dato.cliente)
			break;
		else
			{
				l1=l1->next;
				l2=l2->next;
			}
		l2->next=aux;
		aux->next=l1;
	}

void vis_lista(struct atomo *tl)
{
	struct atomo *aux;

	aux=tl;
	while(aux!=NULL)
		{
			printf("Titolo:%s\n",aux->dato.titolo);
			printf("Codice cliente:%d\n",aux->dato.cliente);
			printf("Giorno:%s\n",aux->dato.giorno);
			aux=aux->next;
			}
}

void libera_lista(struct atomo **tl)
{
	struct atomo *aux;
	while(*tl!=NULL)
		{
			aux=*tl;
			*tl=aux->next;
			free(aux);
		}
	}

void menu()
{
	printf("GESTIONE DEI DVD E DEI PRESTITI \n\n");
	printf("Scegli tra:\n\n");
	printf("1)Inserimento di un nuovo dvd\n");
	printf("2)Visualizzazione dei dvd di un certo genere\n");
	printf("3)Inserimento ordinato di un prestito in lista\n");
	printf("4)Visualizzazione dei prestiti relativi a un genere\n");
	printf("5)Salva\n");
	printf("0)Fine\n\n");
}







void salva(dvd *T[4],int *N)
{
	FILE *pf;
	int i;
	pf=fopen("dvd.dat","wb");
	if(pf!=NULL)
		{ for(i=0;i<4;i++)
	         fwrite(T[i],sizeof(dvd),N[i],pf);
		  fclose(pf);
	}
	else printf("Errore in scrittura\n");
}

void inizializza(dvd *T[4], int *N)
{
	dvd d;
    FILE *pf;

	printf("Inizializzazione\n");
	pf=fopen("dvd.dat","rb");
	if(pf!=NULL)
		{ while(fread(&d,sizeof(dvd),1,pf))
	        ins_tab(T,N,d);
		  fclose(pf);
	    }
	else printf("Nessuna operazione precedentemente salvata\n");
}



